# frozen_string_literal: true

module SolidusFavorites
  class Engine < Rails::Engine
    isolate_namespace Spree
    engine_name 'solidus_favorites'

    config.autoload_paths += %W(#{config.root}/lib)

    # use rspec for tests
    config.generators do |g|
      g.test_framework :rspec
    end

    initializer 'solidus_favorites.environment', before: :load_config_initializers do
      SolidusFavorites::Config = SolidusFavorites::Configuration.new
    end

    def self.activate
      Dir.glob(File.join(File.dirname(__FILE__), '../../app/**/*_decorator*.rb')) do |c|
        Rails.configuration.cache_classes ? require(c) : load(c)
      end
    end

    config.to_prepare(&method(:activate).to_proc)
  end
end
